exception To_string_failed
val debug : bool
val heap2s : (Types.fromlexer * (int * Types.where * 'a)) list -> string
val to_string : Types.fromlexer -> string
val to_string_ : Types.fromlexer -> string
val extract_pos : Types.fromlexer -> Types.pos
val can_mop : Types.fromlexer -> bool
val hole : Types.fromlexer * (int * [> `NotOp] * [> `None])
val l_expr :
  (string * (int * Types.where * ([< `None | `Left | `Right > `None] as 'a)))
  list ->
  (string * (int * Types.where * 'a)) list ->
  Types.fromlexer list -> Types.fromlexer
val rmm : string list list -> Types.fromlexer -> Types.fromlexer
val cleanup :
  Types.fromlexer ->
  ([> `Call of 'a * 'a
    | `Fqid of string * string * Types.pos
    | `Id of string * Types.pos
    | `Constr of string * Types.pos
    | `Float of float * Types.pos
    | `String of string * Types.pos
    | `Fqconstr of string * string * Types.pos
    | `Sep of string * 'a list] as 'a)
val grouper :
  Types.all_operators -> Types.fromlexer list -> Types.fromgrouper
