val unit : Types.fromrewrite
val bottom : Types.fromrewrite
val anyval : Types.fromrewrite
val superval : Types.fromrewrite
val subval : Types.fromrewrite
val abstract : string -> string -> Types.fromrewrite
val abstract_strict : Types.fromrewrite
val debug : bool
val reff : 'a -> 'a ref ref
val var_depth : Types.fromrewrite -> int option
val var_indice : Types.fromrewrite -> int
val var_package : Types.fromrewrite -> string
val deref : Types.fromrewrite -> Types.fromrewrite
val allt2l : Types.fromrewrite -> Types.fromrewrite list
val or2l : Types.fromrewrite -> Types.fromrewrite list
val l2allt : Types.fromrewrite list -> Types.fromrewrite
val l2or : Types.fromrewrite list -> Types.fromrewrite
val l2or_ : Types.fromrewrite list -> Types.fromrewrite list
val l2allt_ : Types.fromrewrite list -> Types.fromrewrite list
val orallt2l :
  Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite list
val l2orallt :
  Types.fromrewrite -> Types.fromrewrite list -> Types.fromrewrite
val allt2l_func : Types.fromrewrite -> Types.fromrewrite list
val allt_expand_call : Types.fromrewrite -> Types.fromrewrite list
val is_same : Types.fromrewrite -> Types.fromrewrite -> bool
val is_same_l : Types.fromrewrite list -> Types.fromrewrite list -> bool
val is_const : Types.fromrewrite -> bool
val is_special_constr : Types.fromrewrite -> bool
val is_simple_const : Types.fromrewrite -> bool
val is_func : Types.fromrewrite -> bool
val is_float : Types.fromrewrite -> bool
val is_string : Types.fromrewrite -> bool
val is_char : Types.fromrewrite -> bool
val is_var : Types.fromrewrite -> bool
val is_local_var : Types.fromrewrite -> bool
val is_global_var : Types.fromrewrite -> bool
val is_external : Types.fromrewrite -> bool
val is_capitalised_var : Types.fromrewrite -> bool
val detype : Types.fromrewrite -> Types.fromrewrite
val is_allt : Types.fromrewrite -> bool
val is_or : Types.fromrewrite -> bool
val is_orallt : Types.fromrewrite -> bool
val is_abstract : Types.fromrewrite -> bool
val is_open_function : Types.fromrewrite -> Types.fromrewrite option
val is_strict : Types.fromrewrite -> bool
val is_dynamic : Types.fromrewrite -> bool
val is_superval : Types.fromrewrite -> bool
val is_subval : Types.fromrewrite -> bool
val is_anyval : Types.fromrewrite -> bool
val is_overload : Types.fromrewrite -> bool
val inout : Types.fromrewrite -> Types.fromrewrite
val un_inout : Types.fromrewrite -> Types.fromrewrite
val l2or_option : Types.fromrewrite list -> Types.fromrewrite option
val l2allt_option : Types.fromrewrite list -> Types.fromrewrite option
val or2or_option : Types.fromrewrite -> Types.fromrewrite option
val allt2allt_option : Types.fromrewrite -> Types.fromrewrite option
val overload :
  (Types.fromrewrite * Types.fromrewrite) list -> Types.fromrewrite
val unoverload :
  Types.fromrewrite -> (Types.fromrewrite * Types.fromrewrite) list
val is_simple_const2 : Types.fromrewrite -> bool
val unoverload_simple : Types.fromrewrite -> Types.fromrewrite
val unoverload_const : Types.fromrewrite -> Types.fromrewrite
val rew_map :
  (Types.fromrewrite -> Types.fromrewrite) ->
  Types.fromrewrite -> Types.fromrewrite
val rew_map_once :
  (Types.fromrewrite -> Types.fromrewrite option) ->
  Types.fromrewrite -> Types.fromrewrite
val rew_map_once_ :
  (int * Types.fromrewrite -> Types.fromrewrite option) ->
  int -> Types.fromrewrite -> Types.fromrewrite
val rew_iter_once :
  (int -> Types.fromrewrite -> bool) -> int -> Types.fromrewrite -> unit
val rew_map_ :
  (int * Types.fromrewrite -> Types.fromrewrite) ->
  Types.fromrewrite -> Types.fromrewrite
val rew_map_withenv :
  ('a -> int * Types.fromrewrite -> Types.fromrewrite * 'a) ->
  'a -> Types.fromrewrite -> Types.fromrewrite * 'a
val rew_map_shallow_withenv :
  ('a -> Types.fromrewrite -> Types.fromrewrite * 'a) ->
  'a -> Types.fromrewrite -> Types.fromrewrite * 'a
val rew_map_leaf :
  (int * Types.fromrewrite -> Types.fromrewrite) ->
  Types.fromrewrite -> Types.fromrewrite
val rew_map_leaf_valpart :
  (int * Types.fromrewrite -> Types.fromrewrite) ->
  Types.fromrewrite -> Types.fromrewrite
val rew_map_leaf_no_val :
  (int * Types.fromrewrite -> Types.fromrewrite) ->
  Types.fromrewrite -> Types.fromrewrite
val rew_map_leaf__option :
  (int * Types.fromrewrite -> Types.fromrewrite option) ->
  Types.fromrewrite -> Types.fromrewrite option
val rew_collect :
  (Types.fromrewrite -> 'a list) -> Types.fromrewrite -> 'a list
val rew_collect_ :
  (int * Types.fromrewrite -> 'a list) -> Types.fromrewrite -> 'a list
val rew_collect_leaf :
  (int * Types.fromrewrite -> 'a list) -> Types.fromrewrite -> 'a list
val rew_collect_leaf_no_val :
  (int * Types.fromrewrite -> 'a list) -> Types.fromrewrite -> 'a list
val rew_remap_locals_ : int -> int -> Types.fromrewrite -> Types.fromrewrite
val rew_remap_locals : int -> Types.fromrewrite -> Types.fromrewrite
val rew_replace_localvar :
  int -> int -> Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite
val rew_collect_vars : int -> Types.fromrewrite -> Types.fromrewrite list
val rew_collect_local_vars : Types.fromrewrite -> int list
val rew_collect_vars_l :
  int -> Types.fromrewrite list -> Types.fromrewrite list
val rew_collect_all_accessible_vars :
  Types.fromrewrite -> Types.fromrewrite list
val rew_collect_all_accessible_local_vars :
  Types.fromrewrite -> Types.fromrewrite list
val rew_collect_all_accessible_vars_no_val :
  Types.fromrewrite -> Types.fromrewrite list
val getpos : Types.fromrewrite -> Types.pos
val sep2l : Types.fromrewrite -> Types.fromrewrite list
val sep2l_ : Types.fromrewrite -> Types.fromrewrite list
val sep2non_empty_l : Types.fromrewrite -> Types.fromrewrite list
val l2sep : Types.fromrewrite list -> Types.fromrewrite
val l2sep_ : Types.fromrewrite list -> Types.fromrewrite
val sep2nb : Types.fromrewrite -> int
val unlazy_and_alike :
  Types.fromrewrite -> Types.fromrewrite * [> `Lazy | `Dynamic] option
val lazy_and_alike2rew :
  Types.fromrewrite -> [< `Lazy | `Dynamic] option -> Types.fromrewrite
val is_abstract2 : Types.fromrewrite -> bool
val is_abstract2_bounded : Types.fromrewrite -> bool
val no_abstract : Types.fromrewrite -> bool
val superval2anyval : Types.fromrewrite -> Types.fromrewrite
val bool2rew : bool -> Types.fromrewrite
val rew2bool : Types.fromrewrite -> bool
val global2name : Types.fromrewrite -> string
val rew_compare : Types.fromrewrite -> Types.fromrewrite -> int
val rew_sort : Types.fromrewrite list -> Types.fromrewrite list
val rew_pack_locals : Types.fromrewrite list -> Types.fromrewrite list * int
val sort_defs :
  (Types.fromrewrite * 'a * int list) list ->
  (Types.fromrewrite * 'a * int list) list
val rew_remove_unused_sepl : Types.fromrewrite -> Types.fromrewrite
val may_be_a_func : Types.fromrewrite -> bool
val has_dynamic_para : Types.fromrewrite -> bool
val create_sequence :
  Types.fromrewrite list -> Types.fromrewrite -> Types.fromrewrite
val add_packed_constr :
  Types.fromrewrite list -> Types.fromrewrite -> Types.fromrewrite
val l2orallt_factorize_constr :
  Types.fromrewrite -> Types.fromrewrite list -> Types.fromrewrite
val compute_nbpara_bounds :
  Types.fromrewrite list -> int * [> `NoLimit | `Strict]
val adjust_para :
  Types.fromrewrite -> Types.fromrewrite list -> Types.fromrewrite option
val less_io : Types.tinoutness * Types.tinoutness -> bool
val max_io : Types.tinoutness -> Types.tinoutness -> Types.tinoutness
val rew2io : Types.fromrewrite -> Types.tinoutness * Types.fromrewrite
val io2rew : Types.fromrewrite -> Types.tinoutness -> Types.fromrewrite
val inv_io : Types.tinoutness -> Types.tinoutness
val rew_collect_with_io :
  (Types.tinoutness * int * Types.fromrewrite -> 'a list) ->
  Types.tinoutness * Types.fromrewrite -> 'a list
val mark_as_val_simple : Types.fromrewrite -> Types.fromrewrite
val mark_as_val : Types.fromrewrite -> Types.fromrewrite
val mark_as_typ : Types.fromrewrite -> Types.fromrewrite
val constr_is_open_function : Types.tconstraint -> bool
val full_deref : Types.fromrewrite -> Types.fromrewrite
val full_deref_no_func : Types.fromrewrite -> Types.fromrewrite
val flatten_tuple : Types.fromrewrite -> Types.fromrewrite
val l2tuple : Types.fromrewrite list -> Types.fromrewrite
val tuple2l_ : Types.fromrewrite -> Types.fromrewrite list option
val tuple2l : Types.fromrewrite -> Types.fromrewrite list
val check_no_mixed_var_in_or : Types.fromrewrite -> unit
