val debug : bool
val part_of_eta_expand : Types.fromrewrite -> Types.fromrewrite
val eta_expand_again :
  Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite
val unpack_one_local_constr :
  Types.fromrewrite -> bool * Types.fromrewrite * Types.tconstr
val normalize_funcs_handling_constraints :
  Types.fromrewrite list -> Types.fromrewrite list
val normalize : Types.fromrewrite -> Types.fromrewrite
val normalize_l : Types.fromrewrite list -> Types.fromrewrite list
val l2ors : Types.fromrewrite list -> Types.fromrewrite list
val l2allts : Types.fromrewrite list -> Types.fromrewrite list
val get_var_typ_unaliased :
  Types.env -> Types.fromrewrite -> Types.tconstraint
val set_var_typ_raw_unaliased :
  Types.env -> Types.fromrewrite -> Types.tconstraint -> Types.env
val propagate_vartype_simple :
  Types.env -> Types.fromrewrite -> Types.fromrewrite
val propagate_vartype : Types.env -> Types.fromrewrite -> Types.fromrewrite
val propagate_vartype_no :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite
val normalize_constr : Types.tconstr -> Types.tconstr
val allocate_new_locals :
  int ->
  [< `None
   | `NoPreAllocate of Types.fromrewrite
   | `PreAllocate of Types.fromrewrite] ->
  Types.env -> Types.fromrewrite * Types.env
val pop_stackt_allocate : Types.env -> Types.env
val lazyfy_and_alike : Types.env -> Types.fromrewrite -> Types.fromrewrite
val simplify_once :
  bool -> Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val simplify_ :
  bool -> Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val simplify :
  Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val simplify_no_propagate :
  Types.env -> Types.fromrewrite -> Types.fromrewrite
val wrap_close_the_world :
  bool ->
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite
val reformat_to_exhibit_call_ :
  Types.fromrewrite ->
  (Types.fromrewrite * Types.fromrewrite) option *
  (Types.fromrewrite * Types.fromrewrite) option
val reformat_to_exhibit_call :
  Types.fromrewrite -> (Types.fromrewrite * Types.fromrewrite option) option
val reformat_to_exhibit_call_factorizing_para :
  Types.fromrewrite -> (Types.fromrewrite * 'a option) option
val add_strict_to_abstract_constraints :
  (int -> bool) -> Types.fromrewrite -> Types.fromrewrite
