val debug : bool
val tabsize_default : int
val pervasives_imports : Common.StringSet.t
val is_space : Types.fromlexer -> bool
val getpos : Types.fromlexer -> Types.pos
val parse_arounds :
  (string * string) list -> Types.fromlexer list -> Types.fromlexer list
val parse_pragmas :
  Types.fromlexer list ->
  Types.all_operators * Common.StringSet.elt list *
  Common.StringSet.elt list * Types.fromlexer list
val indent :
  (string * ('a * ([> `Infix | `Separator] as 'b) * 'c)) list ->
  (string * ('a * 'b * 'c)) list ->
  Types.fromlexer list -> Types.fromlexer list
val add_ops :
  Types.all_operators -> Types.all_operators -> Types.all_operators
val ops_empty : Types.all_operators
val add_pretty_printer_ops : Types.all_operators -> unit
val parse_all1 :
  Types.fromlexer list ->
  Types.all_operators * Common.StringSet.elt list *
  Common.StringSet.elt list * Types.fromlexer list
val parse_all2 :
  Types.all_operators -> Types.fromlexer list -> Types.fromlexer list
